//-----------------------------------------------
//-----------------------------------------------
#include <SoftwareSerial.h>

#define OPERATION_STEP_0  0
#define OPERATION_STEP_1  1
#define OPERATION_STEP_2  2
#define OPERATION_STEP_3  3

#define OPERATION_STEP_ERROR  100

String uartString = "";
unsigned int currentStep;
unsigned int oldStep;

SoftwareSerial bleSerial(A0, A1); // RX, TX
//-----------------------------------------------
//for Sensor
long sendingInterval = 1000;
long previousMillis = 0;

int sensorPin1 = A2;
int sensorPin2 = A3;
int sensorPin3 = 5;
int sensorValue1 = 0;
int sensorValue2 = 0;
int sensorValue3 = 0;
//-----------------------------------------------
void initUart()
{
  uartString = "";
}

void initFlag()
{
  currentStep = OPERATION_STEP_1;
  oldStep = OPERATION_STEP_1;
}

void checkNextStep()
{
  oldStep = currentStep;
  currentStep = OPERATION_STEP_0;
}

void returnOldStep()
{
  currentStep = oldStep;
  currentStep++;
}

void checkCrLfProcess()
{
  while(bleSerial.available())
  {
    char inChar = bleSerial.read();
    uartString += inChar;
    //
    if( uartString.length() > 4
     && uartString.startsWith("\r\n")
     && uartString.endsWith("\r\n") )
    {
      returnOldStep();
      break;
    }
  }
}
//-----------------------------------------------
//-----------------------------------------------
void setup()
{
  Serial.begin(9600);
  Serial.println("Test Started!");
  bleSerial.begin(9600);
  initFlag();
  initUart();

  pinMode(sensorPin3, INPUT);
}

void loop()
{
  switch(currentStep)
  {
    case OPERATION_STEP_0:
      checkCrLfProcess();
    break;
    case OPERATION_STEP_1:
      delay(2000);
      bleSerial.flush();
      initFlag();
      initUart();
       while(bleSerial.available())
      {
        bleSerial.read();
      }
      checkNextStep();
    break;
    case OPERATION_STEP_2:
      if(uartString.startsWith("\r\nCONNECT "))
      {
        delay(1000);
        initUart();
        Serial.println("CONNECT OK");
        currentStep++;
      }
      else
      {
        initUart();
        Serial.println("CONNECT ERROR");
        currentStep = OPERATION_STEP_ERROR;
      }
    break;
    case OPERATION_STEP_3:
    {
      unsigned long currentMillis = millis();
      if(currentMillis - previousMillis > sendingInterval)
      {
        previousMillis = currentMillis;
        
        sensorValue1 = analogRead(sensorPin1);
        sensorValue2 = analogRead(sensorPin2);
        sensorValue3 = digitalRead(sensorPin3);

        bleSerial.print(sensorValue1,HEX);
        bleSerial.print("  ");
        bleSerial.print(sensorValue2,HEX);
        bleSerial.print("  ");
        bleSerial.print(sensorValue3,HEX);
        bleSerial.print("\r");

        Serial.print(sensorValue1,HEX);
        Serial.print("  ");
        Serial.print(sensorValue2,HEX);
        Serial.print("  ");
        Serial.println(sensorValue3,HEX);
      }
    }
    break;

    default:
      if(bleSerial.available())
        Serial.write(bleSerial.read());
      if(Serial.available())
        bleSerial.write(Serial.read());
    break;
  }
}
